/*
 * RunBatchMode.java
 *
 * Created on 7 de junio de 2006, 23:34
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen;


import objectgen.activitymodel.*;
import objectgen.activitymodel.xmi.XMIFileSaver;
import objectgen.testobjective.*;
import objectgen.usecase.*;

import java.io.File;
import java.io.FileFilter;
import java.io.IOException;

import org.apache.log4j.PropertyConfigurator;
import org.apache.log4j.BasicConfigurator;

/**
 * This class allows to generate a set of test objectives from all
 * the use cases found in directory indicated.
 * If no directory indicated, use cases are searched in 
 * './UseCases' dir.
 *
 */
public class RunBatchMode 
    implements FileFilter
{
    
  
    /** Creates a new instance of RunBatchMode */
    public RunBatchMode () {
    }
  
    
    /** Cheks if the argument is a valid directory and 
     * returns a file to manage it
     **/
    File checkDirectory(String dir) {
        File directory = new File(dir);
        
        if (directory.isDirectory () == false) {
            System.out.println(directory + " is not a directory.");
            System.exit (-1);
        }
        
        return directory;
    }
    
    /** Generates the name of the XMI file **/
    String generateXMLFileName(File f) {
        
        String s = f.toString ().substring (0, f.toString ().length ()-1);
        return s + "i";
    }
    
    /** Generates the name of the test objective file **/
    String generateTOFileName(File f) {
        
        String s = f.toString ().substring (0, f.toString ().length ()-4);
        s += "_" + objectgen.configuration.Configuration.Get ("ObjectiveCriterion", "");
        s += ".";
        return s + "tol";
    }

    
    /** **/
    public void generate(String dir) 
    throws Exception
    {
        File directory;
        File[] files;
        int c;
        String[] callMain = new String [3];
        
        System.out.println("Searching for use cases in: " + dir);
        directory = checkDirectory(dir);
        
        files = directory.listFiles (this);
        if (files.length == 0) {
            System.out.println("No XML files found in " + directory);
            System.exit (-1);
        }
        
        for (c = 0; c < files.length; c++) {
            System.out.println ("Procesing: " + files[c]);
            //generateTestObjectives(files[c]);
            callMain[0] = files[c].toString ();
            callMain[1] = this.generateXMLFileName (files[c]);
            callMain[2] = this.generateTOFileName (files[c]);
            OGCommandLine.main (callMain);
        }
         
    }
    
    /** **/
    public static void main(String[] args) 
    throws Exception
    {
        
        //--- Configure logs -----------
        BasicConfigurator.configure ();
        PropertyConfigurator.configure(/*path+*/"./config/logs.prop");
        objectgen.configuration.Configuration.Create ();

        
        RunBatchMode rbm = new RunBatchMode();
        if (args.length == 0) {
            rbm.generate ("./UseCases");
        } else
            rbm.generate ( args[0] );
        System.out.println ("Finished.");
    }
    
    //--- Interface FileFilter --------------------------------------
    public boolean accept(File pathname) {
        String name = pathname.toString ();
        return name.endsWith ("xml");
    }
    
}
