/*
 * Activity.java
 *
 * Created on 13 de abril de 2006, 13:31
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.activitymodel;

/**
 *
 * @author Rincew
 */
public class Activity 
    implements Cloneable, IControlFlow, java.io.Serializable
{
    
    //--- Attributes ---------
    
    /** Id of the next activity **/
    protected String next;
    protected String id;
    protected String description;
    /** Who performs the activity **/
    protected String participant;
    
    
    /** Creates a final node **/
    public static Activity BuildFinal() {
        Activity f = new Activity();
        f.setId ("End");
        return f;
    }
    
    /** Creates a new instance of Activity */
    public Activity () {
        this.next = null;
        this.description = "";
    }
    
    /** Indicates if is a desition node.
     *  Always retruns false **/
    public boolean isDesicion() {
        return false;
    }
    
    /** Indicates if this activity is a final node **/
    public boolean isFinal() {
        if (this.id == null) {
            System.err.println ("Identificador nulo");
            return false;
        }
        return (this.id.compareTo("End")==0);
    }

    /** Gets the next node **/
    public String getNext () {
        return next;
    }

    /** Sets the next node **/
    public void setNext (Activity next) {
        if (next == null)
            return;
        this.next = next.getId ();
    }
    public void setNext (String next) {
        this.next = next;
    }

    public String getId () {
        return id;
    }

    public void setId (String id) {
        this.id = id;
    }

    public String getDescription () {
        return description;
    }

    public void setDescription (String description) {
        this.description = description;
    }
    
    public void setParticipant(String p) {
        this.participant = p;
    }
    
    public String getParticipant() {
        return this.participant;
    }
    
    /**
     * Checks if is next
     **/
    public boolean isNext(Activity node) {
        String id = node.getId ();
        if (id == null)
            return false;
        if (this.next == null)
            return false;
                
        id = id.trim ().toLowerCase ();
        String next = this.getNext ().trim ().toLowerCase ();
        
        return (id.compareTo (next) == 0);
    }

    
    
    /** For testing purpouse **/
    public String toString() {
         String s = "<<" + this.participant + ">> " 
             + id + ": " + description + " -> ";
         if (this.next == null)
             s += "null";
         else {
             s += this.next;
         }
         return s;
    }

    /** Clne public implementation **/
    public Object clone() {
        try {
            Activity a = (Activity) super.clone();
            a.id = this.id;
            a.description = this.description;
            a.next = this.next;
            return a;
        } catch (CloneNotSupportedException ex) {
            ex.printStackTrace();
        }
        return null;
        
    }
    
    /*****     ****/
    public boolean equals(Object o) {
        Activity a = (Activity) o;
        return (a.getId ().compareTo (this.getId ()) == 0);
    }
    
}
