/*
 * Decision.java
 *
 * Created on 13 de abril de 2006, 13:35
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.activitymodel;

import java.util.ArrayList;
import java.util.Iterator;

import org.apache.log4j.*;

/**
 *
 * @author Rincew
 */
public class Decision 
    extends Activity
    implements Iterator, java.io.Serializable
{
    
    //--- Atreibutes --------------------
    
    /** Stores the several alternatives of a decision **/
    protected ArrayList next;
    
    /** Allowa to calculate an id for the desicions **/
    protected static int IdIndex = 0;
    
    //--- Iterator attributes -----------
    int index;
    int size;
    
    /** Creates a new instance of Decision */
    public Decision () {
        super();
        this.id = "";
        this.next = new ArrayList();
    }
    
    /** Overloaded.
     * Now, ids are setted automatically by this class
     */
    public void setId(String id) {
                
        if (this.id.compareTo ("") == 0)
            this.id = GenerateId(id);
                //"D_" + /*(++Decision.IdIndex)*/id;
        
        log.debug ("Called setId with " + id + 
                    " Id is " + this.id);
    }
    
    /** Always returns true **/
    public boolean isDesicion() {
      return true;
    }
    
    /** Always returns null **/    
    public String getNext () {
        log.warn ("Calling getNext() in a decision node has no-sense. ");
        return null;
    }

    /** Add a new alternative branch **/
    public void setAlternative (Alternative alternative) {
        this.next.add (alternative);
    }
    
    /** Paths has only one alternative **/
    public Alternative getFirstAlternative() {
        Object o = this.next.get (0);
        if (o == null) {
            log.warn ("First alternative null in: " + this);
        }
        return (Alternative)o;
    }

    
    /** Returns the condition to go to the activity with the
     * specified id.
     * This method is usefull when generating guards in
     * XMI behavioural model
     **/
     public String getConditionForNode(String id) {
         Alternative alt;
         Iterator it = this.iterator ();
         
         while( it.hasNext () ) {
             alt = (Alternative) it.next ();
             if ( alt.getNext ().toLowerCase ().compareTo (id.toLowerCase ()) == 0 )
                 return alt.getCondition ();
         }
         
         log.warn ("Alternative linked to node '"+id+"' not found.");
         return "";
     }
    
     
     /** Return the number of alternatives **/
     public int alternativeNumber() {
         return this.next.size ();
     }
     
     /** Changes the next node of an aternative from 
      * da to d
      **/
     void changeAlternativeNext(Decision da, Decision d) {
        Alternative alt;
        Iterator it = this.iterator ();
        
        while (it.hasNext ()) {
            alt = (Alternative) it.next ();
            if (alt.isNext (da))
                alt.setNext (d);
        }
     }
     
    //-- Iterator methods -------------------
    
     /** Returns an iterator for travesin alternatives */
    public Iterator iterator() {
        this.index = -1;
        this.size = this.next.size ();
        return this;
    }
    
    public boolean hasNext () {
        return (this.index < (this.size-1));
    }

    public Object next () {
        if (this.size != this.next.size() )
            throw new java.lang.AbstractMethodError();
        
        if (this.index >= this.size)
            throw new java.lang.AbstractMethodError();
        
        return this.next.get((++this.index));
                
    }

    /** Not implemented ***/
    public void remove () {
        throw new java.lang.AbstractMethodError();
    }

    /** For testing purpouse **/
    public String toString() {
        String s = "<<" + this.participant + ">> "  
            + id + ": " + description + "\n" ;
        int c;
        for (c = 0; c < this.next.size (); c++) {
            s +=  ((Alternative) this.next.get (c) );
            s += " / ";
        }
        return s;
    }

    
    //--- Static Methods ------------------------------------------------
    
    /** This method allos to create decisions with only one alternative
     * for test objectives **/
    public static Decision BuildDesicion(Decision d, Alternative alt) {
        Decision new_d = new Decision();
        
        new_d.description = d.description;
        new_d.id = d.id;
        new_d.participant = d.participant;
        
        new_d.setAlternative (alt);
        
        return new_d;
    }
    
    /** This method returns the id for a desicion 
     *  @param stepId is the ide of the alternative or erroneous step
     **/
    public static String GenerateId(String stepId) {
        // Old
        return "D0" + (++Decision.IdIndex);
        // New
        //return "D_" + stepId;
    }
    
    //--- Log ------------------------------------------------------------
    static Logger log;
    static {
        log = Logger.getLogger (Decision.class.getName());
    }

}
