/*
 * BuildBehaviourModelCommand.java
 *
 * Created on 13 de mayo de 2006, 23:42
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.gui.commands;


import java.io.File;
import java.io.IOException;
import java.util.Set;

import objectgen.activitymodel.*;
import objectgen.activitymodel.xmi.XMIFileSaver;
import testgen.gui.dataspace.DataSpace;
import objectgen.testobjective.*;
import objectgen.usecase.*;
import objectgen.configuration.Configuration;


/**
 * This class encapsulates the bussiness logic for generate 
 * an XMI file with an activity diagram from
 * the chosen use case.
 * 
 */
public class BuildBehaviourModelCommand {
    
    /** Creates a new instance of BuildBehaviourModelCommand */
    public BuildBehaviourModelCommand () {
        
    }

    /** Runs the command
     * @return a text indicating an error message or a text
     * listing the participants in the use case.
     */
    public String run (String file_org, String file_des) {
        
        DataSpace ads = DataSpace.getInstance ();
        Set participants;
        StringBuffer logOut = new StringBuffer("");
        int index;
        
        File f_org = new File(file_org);
        File f_des = new File(file_des);
        
        if (f_org.exists () == false) {
            return "File '" + file_org + "' does not exist.";
        }
        /*if (f_des.exists () == true) {
            return "File '" + file_des + "' exists. Overwritting.";
        }*/

        UseCaseXML uc = new UseCaseXML();
        try {
            uc.load (f_org);
        } catch (UseCaseXMLException ex) {
            return ex.toString ();
        }
        
        ActivityDiagram ad;
        ActivityDiagramGenerator adg = new ActivityDiagramGenerator();
        ad = adg.generate (uc);
        
        if ( ("no".compareTo(Configuration.Get ("JoinAlternatives", "yes")) != 0) && 
             ("No".compareTo(Configuration.Get ("JoinAlternatives", "yes")) != 0) ) {
            JoinAlternativeFilter filter = new JoinAlternativeFilter();
            filter.filter (ad);
        }

        
        XMIFileSaver xmiSaver = new XMIFileSaver();
        try {
            xmiSaver.save (f_des, ad);
        } catch (IOException ex) {
            
            ex.printStackTrace();
            return ex.toString ();
        }
    
        ads.put ("ActivityDiagram", ad);
        
        logOut.append ("Actors:   \n");
        logOut.append ("--------------------------\n");
        
        participants = ad.generateParticipants ();
        for (index=0; index < participants.size (); index++)  {
            logOut.append (participants.toArray ()[index] + "\n" );
        }
        logOut.append ("\nOk.\n");
        
        return logOut.toString ();
    }
}
