/*
 * GenerateTestObjectivesCommand.java
 *
 * Created on 23 de abril de 2006, 11:57
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.gui.commands;

import objectgen.activitymodel.*;
import objectgen.testobjective.*;
import objectgen.usecase.*;
import objectgen.configuration.Configuration;

import java.io.File;
import java.io.FileNotFoundException;

/**
 * Executes the generate objectives command.
 * @author Rincew
 */
public class GenerateTestObjectivesCommand {
    
    /** Creates a new instance of GenerateTestObjectivesCommand */
    public GenerateTestObjectivesCommand () {
        
    }
    
    /** Executes the generate objectives command.
     **/
    public String run (String file) {
        
        File f = new File(file);
        
        if (f.exists () == false) {
            return "File '" + file + "' does not exist.";
        }
        
        UseCaseXML uc = new UseCaseXML();
        try {
            uc.load (f);
        } catch (UseCaseXMLException ex) {
            return ex.toString ();
        }
        
        ActivityDiagram ad;
        ActivityDiagramGenerator adg = new ActivityDiagramGenerator();
        ad = adg.generate (uc);

        if ( ("no".compareTo(Configuration.Get ("JoinAlternatives", "yes")) != 0) && 
             ("No".compareTo(Configuration.Get ("JoinAlternatives", "yes")) != 0) ) {
            JoinAlternativeFilter filter = new JoinAlternativeFilter();
            filter.filter (ad);
        }
        
        ITestObjectiveCriterion tog = objectgen.testobjective.CoverageCriteriaFactory.Get ();
        TestObjectiveList tol = tog.generate (ad);
        
        return  "Using: " +  objectgen.testobjective.CoverageCriteriaFactory.GetName () 
                + "\n\n" + 
                "Test Objectives: \n" + 
               "---------------------------------\n" + 
               tol.toString ();
    }
    
}
