/*
 * AlternativeStore.java
 *
 * Created on 31 de mayo de 2006, 21:47
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.testobjective;

import objectgen.activitymodel.Decision;
import objectgen.activitymodel.Alternative;

import java.util.Hashtable;
import java.util.ArrayList;
import java.util.List;
import java.util.Iterator;
import java.util.Enumeration;

import org.apache.log4j.Logger;

/**
 * This class is a helper class of test objective 
 * generator class.
 * This class stores decision nodes and their alternatives to 
 * avoid infinite loops
  */
public class AlternativeStore 
    implements Cloneable
{
    
    Hashtable store;
    
    /** Creates a new instance of AlternativeStore */
    public AlternativeStore () {
        store = new Hashtable();
    }
    
    
    /** Returns true if the store contains the decision
     * Not deprecated but unuseful
     **/
    public boolean containsDecision(Decision d) {
        return this.store.contains(d.getId());
    }
    
    
    /** Add a new decision and all its alternatives
     *  @deprecated
     **/
    public void addDecision(Decision d) {
        Iterator it;
        ArrayList alternatives = new ArrayList();
        
        it = d.iterator ();
        while (it.hasNext ()) {
            alternatives.add (it.next ());
        }
        this.store.put (d.getId (), alternatives);
    }
    
    
    /** Add a desicion and an alternative of that decision
     *  A decision could have more than one alternative stored.
     */
    public void addDecision(Decision d, Alternative a) {
        List alternatives;
        alternatives = (List)this.store.get(d.getId ());
        if (alternatives == null)
            alternatives = new ArrayList();
        alternatives.add (a);
        this.store.remove (d.getId ());
        this.store.put (d.getId (), alternatives);
    }
    
    
    /** @return true if the decision and the alternive are stored
     */
    public boolean stored(Decision d, Alternative a) {
        List alternatives;
        alternatives = (List)this.store.get(d.getId ());
        if (alternatives == null)
            return false;
        
        return alternatives.contains (a);
    }
    
    
    /** Deletes the first alternative in the stores that
     * math with the first alternative of decision d
     * @deprecated
     */
    public void deleteAlternative(Decision d) {
        List alternatives;
        boolean b;
        
                
        alternatives = (List) this.store.get (d.getId ());
        
        if (alternatives.contains (d.getFirstAlternative ()) == false )
            log.warn ("Alternative list: " + alternatives 
                + " does not contains alternative" + d.getFirstAlternative ());
        
        log.debug ("Alternatives before deleting: "+alternatives.size ());
        
        b = alternatives.remove (d.getFirstAlternative ());
        
        log.debug ("Alternatives after deleting: "+alternatives.size ());
                
        if (b == false) {
            log.warn ("No first alternative '" + d.getFirstAlternative ()
                +"' deleted from desicion " + d);
        }
        
    }
    
    /** Returns an iterator to traverse all the alternatives of the
     * stored decision 
     ** @deprecated
     */
    public Iterator iteratorFor(Decision d) {
        List aux = (List)this.store.get (d.getId ());
        
        if (aux == null) {
            log.warn ("No decision stored. Desicion: " + d);
        }
        
        return aux.iterator ();
        
    }
  
    /** Clones an AlternativeStore class
     **/
    public Object clone() 
        throws CloneNotSupportedException 
    {
        // Warning. This method does not clone the value objects
        // stored in the hashtable
        Object key;
        Object value;

        //log.fatal ("Clone mthod not implemented yet.");
        AlternativeStore as = (AlternativeStore) super.clone ();
        //as.store.clear ();
        as.store = new Hashtable();
        
        Enumeration k = this.store.keys ();
        while (k.hasMoreElements ()) {
            key = k.nextElement ();
            value = this.store.get (key);
            as.store.put (key, value);
        }
        return as;
        
    }

    /** Testing purpouses only
     **/
    public String toString() {
        return this.store.toString();
    }
    
    //--- Log ---------------------------
    static Logger log;
    static {
        log = Logger.getLogger (AlternativeStore.class.getName());
    }

}
