/*
 * CoverageCriteriaFactory.java
 *
 * Created on 3 de noviembre de 2006, 10:57
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.testobjective;

import objectgen.configuration.Configuration;

/**
 * A static factory to create an object for the criterium indicated
 * in the configuration file.
 */
public class CoverageCriteriaFactory {
    
    /** No objects from this class
     * Creates a new instance of CoverageCriteriaFactory */
    private CoverageCriteriaFactory () {
    }

    /**
     * Search in the configuration file an returns
     * an object.
     * If there is no info in the config file,
     * this method returns AllScenaros criterium.
     */
    public static ITestObjectiveCriterion Get() {
        
        String criteriumName;
        
        criteriumName = Configuration.Get ("ObjectiveCriterium", 
                                            "AllScenarios");
        
        
        if (criteriumName.toLowerCase ().compareTo ("allactivities") == 0)
            return new AllActivitiesCriterium();
        if (criteriumName.toLowerCase ().compareTo ("alltransitions") == 0)
            return new AllTransitionsCriterium();

        
        return new AllScenariosCriterium();
    }
    
    
    /**
     *Returns the AllActivities criterion
     **/
    public static ITestObjectiveCriterion GetAllActivities() {
        return new AllActivitiesCriterium();
    }
    
    /**
     * Returns the name of the coverage criterion 
     * in the configuration file
     **/
    public static String GetName() {
        return Configuration.Get ("ObjectiveCriterium", 
                                            "AllScenarios");
    }
    
}
