/*
 * TestObjective.java
 *
 * Created on 31 de mayo de 2006, 21:42
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.testobjective;

import objectgen.activitymodel.ActivityDiagram;
import objectgen.activitymodel.Activity;
import objectgen.activitymodel.Decision;
import objectgen.activitymodel.Transition;

import java.util.Enumeration;
import java.util.LinkedList;
import java.util.List;
import java.util.Iterator;

import org.apache.log4j.Logger;

/**
 * A test objective is also an activity diagram
 *
 * @author Rincew
 */
public class TestObjective 
    implements Cloneable,
               java.io.Serializable
{
    
    List activities;
    
    /** Creates a new instance of TestObjective */
    public TestObjective () {
        //super();
        this.activities = new LinkedList();
    }
 
    /** Returns true if the test objective contains the 
     * indicated activity 
     */
    public boolean contains(Activity a) {
        return this.activities.contains(a);
    }
    
    /*****************************************************
     * Returns true if the objective list contains the 
     * transition
     */
    public boolean contains(Transition t) {
        Activity tmp = null;
        Decision d = null;
        int index;
        int aNum;
        int startActivityIndex = -1;
        boolean notFound;
        String o1 = null;
        String o2 = null;
        boolean r = false;

        aNum = this.activities.size ();
        
        notFound = true;
        
        //do {
        
            for (index = 0; index < aNum; index++) {
                tmp = (Activity) this.activities.get (index);

                if (t.startIn (tmp) == false) {
                    continue;
                }
                
                if (t.startIn (tmp) == true) {
                    notFound = false;
                    startActivityIndex = index;
                    //break;
                }
          
        
            if (notFound) {
                //System.out.println ("Start activity not found: " + t );
                r = false;
                //exit = true;
                break;
                
            } else {
                o1 = t.getDes ().toLowerCase ();
                /*if (tmp.isDesicion ()) {
                    d = (Decision) tmp;
                    o2 = d.getFirstAlternative ().getNext ().toLowerCase ();
                } else {
                    o2 = tmp.getNext ().toLowerCase ();
                }*/
                tmp = (Activity) this.activities.get (++startActivityIndex);
                if (tmp == null)
                    o2 = "NULL";
                else
                    o2 = tmp.getId ().toLowerCase ();
                r = (o1.toLowerCase ().compareTo (o2.toLowerCase ()) == 0);
                if (r) 
                    //exit = true;
                    break;
            }
            
        //} while (notFound == false);
          
            } // For
        
        log.debug ("Objective: " + this.toString () + " Contains: " + t 
            + " o1 / o2: " + o1 + " / "+o2+" R: " + r );
        return r;
    }
    
    
    /** Returns the first occurence of the decision d
     *in the test objective
     **/
    public Decision getFirstDecision(Decision d) {
        Activity a_aux;
        Decision aux = null;
        Iterator it = this.activities.iterator ();
        boolean b = true;
        
        while (it.hasNext ()) {
            a_aux = (Activity) it.next ();
            if (a_aux.isDesicion ()) {
                aux = (Decision) a_aux;
            
                if (aux.equals (d)) {
                    b = false;
                    break;
                }
            }
        }
        
        if (b) {
            log.warn("Warning ! No first decision found for " 
                + d + " in " + this.activities);
        }
        
        return aux;
    }
    
    
    /** Returns the last desicion stored in the objective **/
    public Decision getLastDecision() {
        Decision d_aux = null;
        Activity a_aux;
        
        int size;
        int index;
        
        size = this.activities.size ();
        
        for (index = size-1; index > 0; index-- ) {
            a_aux = (Activity) this.activities.get (index);
            if (a_aux.isDesicion ()) {
                d_aux = (Decision) a_aux;
                break;
            }
        }
        
        if (d_aux == null) 
            log.warn("No decision found in test objective: " + this.toString ());
        
        return d_aux;
        
    }

    
    /** 
     */
    public List getActivitiesList() {
        return this.activities;
    }
    
    //--- Activities from ActivityDiagram ------------------
    public void addActivity (Activity a) {
        this.activities.add(a);
    }
    

    /** Clone **/
    public Object clone() {
        TestObjective clon = new TestObjective();
        Enumeration keys;
        Object key;
        Activity tmp;
        Iterator it;
        
        it = this.activities.iterator ();
        while (it.hasNext ()) {
            clon.activities.add ( (Activity) it.next ());
        }
        
        /*
        keys = this.da.keys ();
        while (keys.hasMoreElements ()) {
            key = keys.nextElement ();
            tmp = (Activity)this.da.get (key);
            clon.da.put (key, tmp.clone());
        }
        
        clon.beginNode = (Activity)this.beginNode.clone ();
        clon.finalNode = (Activity)this.finalNode.clone ();
        */
        return clon;
    }

    /** Testing purpouse **/
    public String toString() {
        int c;
        Activity a;
        StringBuffer sb = new StringBuffer("");
        //sb.append ("TO: \n");
        
        for (c = 0; c < this.activities.size(); c++) {
            a = (Activity) this.activities.get (c);
            sb.append ( a.getId ()+ ", ");
        }
            
        //sb.append ( "\n ");
        return  sb.toString ();
    }

    
    /** **/
    public Iterator activitiesIterator() {
        return this.activities.iterator ();
    }
    
    /** **/
    public Iterator transitionsIterator() {
        int index;
        Activity o;
        Activity d;
        Transition t;
        LinkedList tmp = new LinkedList();
        
        // Dejamos fuera la ltima transicin que nos lleva al nodo End
        for (index = 0; index < (this.activities.size ()-1); index ++) {
            o = (Activity) this.activities.get (index);
            d = (Activity) this.activities.get (index+1);
            t = new Transition(o.getId (), d.getId ());
            tmp.add (t);
        }
     
        //System.out.println("Transitions: " + tmp);
        
        return tmp.iterator ();
    }

    
    /** 
     * Returns the number of activities
     **/
    public int getSize() {
        return this.activities.size ();
    }
    
    //--- Log --------
    static Logger log;
    static {
        log = Logger.getLogger (AllScenariosCriterium.class.getName());
    }

}
