/*
 * XMISaver.java
 *
 * Created on 27 de septiembre de 2006, 10:41
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.testobjective.savers;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;

import java.util.Iterator;

import objectgen.testobjective.TestObjectiveList;
import objectgen.testobjective.TestObjective;
import objectgen.activitymodel.ActivityDiagram;
import objectgen.activitymodel.Activity;
import objectgen.activitymodel.xmi.XMIFileSaver;

/**
 * This class generates a new activity diagram for every test objective
 * and stores it in a XMI file
 * @author Rincew
 */
public class XMISaver 
   implements ITestObjectivesSaver

{
    
    int id;
    
    /** Creates a new instance of XMISaver */
    public XMISaver () {
    }

    public void save (File f, TestObjectiveList tol) 
        throws FileNotFoundException, IOException 
    {
        Iterator toi = tol.iterator ();
        this.id = 0;
        while (toi.hasNext ())
            this.saveXMI (f, toi.next ());
    }
    
    
    //----------------
    private void saveXMI(File f, Object o) 
    throws IOException {
        Iterator activities;
        TestObjective to = (TestObjective) o;
        ActivityDiagram ad = new ActivityDiagram();
        Activity last = null;
        Activity first;
        XMIFileSaver fs = new XMIFileSaver();
        
        String fileName;
        File newFileName;
        
        /* Creo que el problema es que no estamos trabajando
         * bien con las desiciones y alternativas */
        activities = to.activitiesIterator ();
        while (activities.hasNext ()) {
            first = (Activity)activities.next ();
            ad.addActivity (first);
            if (last != null)
                ad.addTransition (first, last);
            last = first;
        }
        ad.finalActivity (last);
        
        
        //--- Guardar el diagrama de actividades en un XMI
        fileName = f.toString ();
        fileName = (fileName.split ("\\."))[0];
        newFileName = new File(fileName + (++id) + ".xmi");
        fs.save (newFileName, ad);

    }
    
    /**
     * Unsupported operation
     **/
    public void saveHeaderText (String headerText) {
        System.err.println("Unsupported operation");
    }

}
