/*
 * PatternReaderFactory.java
 *
 * Created on 1 de noviembre de 2006, 10:51
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.usecase.pattern;

import java.io.File;

import objectgen.configuration.Configuration;

import org.apache.log4j.Logger;

/**
 *
 * @author Rincew
 */
public class PatternReaderFactory {
    
    
    
    
    /** Creates a new instance of PatternReaderFactory 
     * No instances of this class are allowed. Use this class with
     *the static methods
     */
    private PatternReaderFactory () {

    }

    
    private static IPatternReader GetPatternReader(String type) {
        File f;
        String idiom;
        String dir;
        String fileName;
        String patternFile;

        // 1. First, we get the language
        idiom = Configuration.Get ("Idiom");
        if (idiom == null) {
            log.info("No property 'Idiom' found in config file." +
                "Using EN idiom.");
            idiom = "EN";
        }
        
        // 2. Then, we get the directory for the language.
        dir = Configuration.Get ("IdiomDirectory_"+idiom);
        if (dir == null) {
            log.info("No property 'IdiomDirectory_" + idiom 
                +"' found in config file." +
                "Using actual directory");
            dir = ".";
        }
        
        fileName = Configuration.Get(type);
        if (fileName == null) {
            log.warn("No property '" + type 
                +"' found in config file." +
                " An ugly null pointer exception is coming soon.");
        }
        
        // 3. We get the file
        patternFile = Configuration.GetPath () + "/" + dir + "/" + fileName;
        if (patternFile == null) {
            log.error ("Pattern file not found: '" + patternFile + "'.");
        }

        f = new File( patternFile );
        if (f.exists () == false ) {
            log.error ("File not found: '" + f + "'.");
        }
        
        IPatternReader pReader = new PatternReader(f);
        log.debug ("Pattern reader created: " + pReader.toString ());
        
        return pReader;
        
    }
    
    //--- Statis methods -----------------
    public static IPatternReader Get(String type) {
        //PatternReaderFactory prf = new PatternReaderFactory();
        return /*prf.*/GetPatternReader (type);
    }

    //--- Log ------------------------------------------------------------
    static Logger log;
    static {
        log = Logger.getLogger (PatternReaderFactory.class.getName());
    }

}
