package valuegen.data;

import java.util.List;
import java.util.ArrayList;

/**
 * @version 1.0
 * @created 26-Dec-2006 13:58:53
 */
public class Variable 
    implements Comparable
{

	private String name;
	private String notes;
	
        /**
	 * Stores the id of the desicion that matches with this variable
	 */
	private String activityId;
	private List partitions;


	/**
	 * 
	 * @param activityId
	 */
	public Variable(String activityId){
            this.activityId = activityId;
            this.notes = "";
            this.partitions = new ArrayList(5);
            this.name = this.buildVariableName();
	}

	/**
	 * 
	 * @param p
	 */
	public void addPartition(Partition p){
            this.partitions.add (p);
	}

	/**
	 * 
	 * @param v
	 */
	public boolean equals(Variable v){
		return false;
	}

	public List getPartitions(){
		return this.partitions;
	}

	public String getName(){
		return this.name;
	}

        /* */
        public String getIdOfFirstPartition() {
            Partition tmp;
            tmp =(Partition) this.partitions.get (0);
            
            return tmp.getId ();
        }
        
        /** Helpper method
         **/
        public String buildVariableName() {
            return "V_" + this.getActivityId();
        }

    public String getActivityId () {
        return activityId;
    }

    public int compareTo (Object o) {
        Variable v = (Variable) o;
        return this.getName ().compareTo (v.getName ());
    }
}