package valuegen.operations;

import valuegen.data.DependencyMatrix;
import valuegen.data.VariableList;
import valuegen.data.NoValueConstraint;
import valuegen.data.ConstraintList;
import valuegen.data.Variable;
import valuegen.operations.TestObjectiveHelpper;

import objectgen.testobjective.TestObjectiveList;
import objectgen.testobjective.TestObjective;
import objectgen.activitymodel.Activity;

import java.util.List;
import java.util.Iterator;

import org.apache.log4j.Logger;

/**
 * @version 1.0
 * @created 26-Dec-2006 13:58:52
 */
public class ConstraintBuilder {
    
    
    public ConstraintBuilder (){
        
    }
    
    /**
     *
     * @param vl
     * @param tol
     */
    public List generate (VariableList vl, TestObjectiveList tol) {
        DependencyMatrix dm;
        dm = this.buildDependencyMatrix (vl, tol);
        log.debug ("\n"+dm.toString ());
        
        return this.buildConstraintsList (tol, dm, vl);
    }
    
    /**
     *
     * @param vl
     */
    protected DependencyMatrix buildDependencyMatrix (VariableList vl, TestObjectiveList tol) {
        DependencyMatrix dm;
        Iterator itTo;
        TestObjective to;
        List aList;
        Activity org, des;
        int i, j;
        
        
        dm = new DependencyMatrix (vl.size ());
        itTo = tol.iterator ();
        while (itTo.hasNext ()) {
            to = (TestObjective) itTo.next ();
            
            System.out.println (to);
            
            aList = to.getActivitiesList ();
            for (i = 0; i < aList.size (); i++) {
                org = (Activity) aList.get (i);
                if (org.isDesicion ()) {
                    for (j = (i+1) ; j < aList.size (); j++) {
                        des = (Activity) aList.get (j);
                        if (des.isDesicion ()) {
                            dm.setDependency (vl.getVariableForNode (org.getId ()).getName (),
                                vl.getVariableForNode (des.getId ()).getName ());
                        }
                    }
                } // Is desicion
            } // Foreach activity
        } // Foreach test objective
        
        return dm;
        
    }
    
    
    /**
     *
     * @param tol
     * @param dm    dm
     */
    protected List buildConstraintsList (TestObjectiveList tol, DependencyMatrix dm, VariableList vll){
        VariableList vl;
        VariableList dvl;
        TestObjectiveHelpper toh;
        ConstraintList cl;
        NoValueConstraint nvl;
        Iterator toIterator;
        Iterator vIterator;
        Iterator dvIterator;
        TestObjective to;
        Variable v;
        Variable dv;
        
        
        toh = new TestObjectiveHelpper ();
        cl = new ConstraintList ();
        toIterator = tol.iterator ();
        while (toIterator.hasNext ()) {
            to = (TestObjective) toIterator.next ();
            vl = toh.getVariablesInTestObjective (to);
            vIterator = vl.iterator ();
            
            log.debug ("Variables in path: " + vl.size ());
            
            while (vIterator.hasNext ()) {
                v = (Variable) vIterator.next ();
                nvl = new NoValueConstraint (v);
                
                dvl = dm.getDependentVariablesFor (v, vll);
                
                log.debug ("Dependency variables for " +
                    v.getName () + " are:" + dvl.size ());
                
                dvIterator = dvl.iterator ();
                while (dvIterator.hasNext ()) {
                    dv = (Variable)dvIterator.next ();
                    if ( vl.contains (dv) == false) {
                        log.debug ("Variables: " + v.getName () + 
                            " makes no value for: " + dv.getName () );
                        nvl.setVariableWithoutValue (dv);
                    } else {
                        log.debug ("-------- Variable: " + dv.getName () + " not conained");
                    }
                }
                
                if (nvl.getVariableWithoutValueList ().size () != 0) {
                    cl.add (nvl);
                } else {
                    log.debug ("No constraint found for variable: " + v.getName ());
                }
                
            }
        }
        
        return cl;
    }
    
    /**
     *
     * @param vOrg
     * @param vDes
     */
    public void createNoValueConstraint (Variable vOrg, Variable vDes){
        
    }
    
    //--- Log ------------------------------------------------------------
    static Logger log;
    static {
        log = Logger.getLogger (ConstraintBuilder.class.getName ());
    }
    
}