package valuegen.operations;

import valuegen.data.VariableList;
import valuegen.data.ConstraintList;

import objectgen.configuration.Configuration;

import java.util.List;
import java.util.Properties;
import java.io.*;

import org.apache.velocity.VelocityContext;
import org.apache.velocity.Template;
import org.apache.velocity.app.Velocity;
import org.apache.velocity.exception.ResourceNotFoundException;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.MethodInvocationException;

import org.apache.log4j.Logger;

/**
 * @version 1.0
 * @created 26-Dec-2006 13:58:52
 */
public class GenerateBSScript {
    
    
    public GenerateBSScript (){
        
    }
    
    
    protected void generateVariableDeclaration (){
        
    }
    
    /**
     *
     * @param cl
     */
    public void generate (List cl, VariableList vl, File outputFile){
        
        String templateName;
        FileWriter file = null;
        List vlsorted;
        Object[] vlobject;
        
        // Sorts variable list, due the order is important.
        vlobject = vl.toArray ();
        java.util.Arrays.sort (vlobject);
        vlsorted = java.util.Arrays.asList (vlobject);
            
        try {
            
            file = new FileWriter (outputFile);
        } catch (IOException ex) {
            ex.printStackTrace ();
            return ;
        }
        
        try {
            Properties p = new Properties();
            p.setProperty("file.resource.loader.path", Configuration.GetPath () + 
                "/" + Configuration.Get ("TemplateDir"));
            Velocity.init( p );
        } catch (Exception ex) {
            ex.printStackTrace ();
            return;
        }
        VelocityContext context = new VelocityContext ();
        context.put ("vl", vlsorted);
        context.put ("cl", cl);
        
        Template template = null;
        templateName =  Configuration.Get ("BeanShellTemplate");
        log.debug ("Template:"+templateName);
        
        try {
            template = Velocity.getTemplate (templateName);
            StringWriter sw = new StringWriter ();
            template.merge ( context, sw );
            
            file.write (sw.toString ());
            
            file.close ();
        } catch( ResourceNotFoundException rnfe ) {
            rnfe.printStackTrace ();
            // couldn't find the template
        } catch( ParseErrorException pee ) {
            pee.printStackTrace ();
            // syntax error : problem parsing the template
        } catch( MethodInvocationException mie ) {
            mie.printStackTrace ();
            // something invoked in the template
            // threw an exception
        } catch( Exception e ) {
            e.printStackTrace ();
        }
    }
    
    //--- Log ------------------------------------------------------------
    static Logger log;
    static {
        log = Logger.getLogger (ConstraintBuilder.class.getName ());
    }
}