package valuegen.operations;

import valuegen.data.Variable;
import valuegen.data.VariableList;
import valuegen.data.Partition;

import java.io.*;
import java.util.Iterator;


/**
 * @version 1.0
 * @created 26-Dec-2006 13:58:53
 */
public class VariableOutputXML {

    private FileWriter file;
    
	public VariableOutputXML(){

	}

	/**
	 * 
	 * @param list
	 */
	public void generate(File f, VariableList vl)
            throws IOException
        {
            Iterator variables;
            Iterator partitions;
            Variable v;
            Partition p;
            
            this.file = new FileWriter(f);
            this.file.write("<?xml version = '1.0' encoding = 'UTF-8' ?> \n");
            this.file.write("\n<variables> \n");
            
            variables = vl.iterator ();
            while (variables.hasNext ()) {
                v = (Variable) variables.next ();
                this.file.write(" <variable id=\"" + v.getName () + "\"> \n");
                partitions = v.getPartitions ().iterator ();
                while (partitions.hasNext ()) {
                    p = (Partition) partitions.next ();
                    this.file.write("  <partition id=\"" + p.getId () + "\"> \n");
                    this.file.write("   <condition> ");
                    this.file.write("    " + p.getCondition ());
                    this.file.write(" </condition> \n");
                    this.file.write("  </partition> \n");
                }
                this.file.write(" </variable> \n");
            }
            
            this.file.write("\n</variables> \n");
            this.file.close ();
	}

}